<template>
  <v-layout column justify-center align-center>
    <v-progress-circular
      :width="3"
      color="red"
      indeterminate
      v-if="is_loading"
    ></v-progress-circular>
    <v-layout v-if="!is_loading">
      <v-btn 
        @click="signout()" 
        v-bind:style="{position: 'absolute', right:'8%'}"
        v-if="is_login && !is_game"
      >
        Signout
      </v-btn>
      <v-flex xs12 sm8 v-if="!is_login">
        <v-card max-width="600" min-width="400">
          <v-btn @click="signin()">Signin with google</v-btn>
        </v-card>
      </v-flex>
      <Game v-if="is_game" />
      <rooms v-if="is_login && !is_game"></rooms>
    </v-layout>
    <!-- <GunUI/> -->
    <!-- <PlayerHpBar/> -->
  </v-layout>
</template>

<script>
//import PlayerHpBar from "../components/PlayerHpBar";
// import GunUI from "../components/GunUI";
//import WinGameOver from "../components/WinGameOver";
import axios from 'axios';
import Rooms from "../components/Rooms";
import Game from "../components/Game";
import { SocketRoomEvents } from '../events/socket/room';

export default {
  components: {
    Rooms,
    Game,
    //WinGameOver
    //PlayerHpBar
    // GunUI
  },
  mounted() {
    this.$store.commit('user/setIsLoading', true);
    gapi.load('client:auth2', this.initClient.bind(this));
  },
  data: () => ({
    name: "",
    password: "",
    game: null,
    socket: null,
    dialog_game: true,
    scope: "https://www.googleapis.com/auth/userinfo.profile",
    //scope: "https://www.googleapis.com/auth/drive.metadata.readonly",
    googleAuth: null
    //is_login:true
  }),
  computed: {
    is_loading(){
      return this.$store.state.user.is_loading;
      //return this.$store.user.state.is_loading;
    },
    is_login() {
      //console.log("Поменялся is_login");
      return this.$store.getters["user/getAuth"];
    },
    is_game() {
      return this.$store.getters["game/isGame"];
    },
  },
  // watch:{
  //     'is_connect':'reconnect'
  // },
  methods: {

    socketConnect(data){
      this.$socket.emit("join", data);
    },

    async serverAuth(id_token){
      try{

        const res = await axios.get(`http://localhost:3000/gauth?token=${id_token}`);
        console.log('id = ', res.data.id);
        this.$socket.connect();
        SocketRoomEvents(this.$socket);
        this.socketConnect({id: res.data.id});
      } catch(err){
        this.$store.commit('user/setIsLoading', false);
        console.error('error = ', err.message);
      }
    },

    updateSigninStatus(){

      if (!this.googleAuth.isSignedIn.get()) {
        this.$store.commit('user/setIsLoading', false);
        return;
      }
      
      const user = this.googleAuth.currentUser.get();
      const profile = user.getBasicProfile();
      const id_token = user.getAuthResponse().id_token;
      this.serverAuth(id_token);
      //console.log('id_token = ', id_token);
      //console.log('user = ', profile.getName());
      //console.log('user = ', profile.getGivenName());
      //console.log('user = ', profile.getFamilyName());
      //console.log('user = ', profile.getImageUrl());
      //console.log('user = ', profile.getEmail());
      //const isAuthorized = user.hasGrantedScopes(this.scope);
    },
    initClient() {

      // Initialize the gapi.client object, which app uses to make API requests.
      // Get API key and client ID from API Console.
      // 'scope' field specifies space-delimited list of access scopes.
      gapi.client
        .init({
          apiKey: "AIzaSyAR88zM7dN6jPwC3wkAqk8upkhHJfNrdDA",
          clientId:
            "321906415579-u6s7etkitai73rodm3e3lm3dcg9nm0l8.apps.googleusercontent.com",
          scope: this.scope,
        })
        .then(()=>{

          this.googleAuth = gapi.auth2.getAuthInstance();
          this.$store.commit('user/setGoogleAuth', this.googleAuth);
          // Listen for sign-in state changes.
          this.googleAuth.isSignedIn.listen(this.updateSigninStatus);
          this.updateSigninStatus();
          // Handle initial sign-in state. (Determine if user is already signed in.)
          // const user = googleAuth.currentUser.get();
          // const isAuthorized = user.hasGrantedScopes(SCOPE);
          // console.log('tyt!!!');
          // if(isAuthorized){
          //   console.log('авторизирован');
          // }else{
          //   console.log('Не авторизирован');
          // }
          //setSigninStatus();

          // Call handleAuthClick function when user clicks on
          //      "Sign In/Authorize" button.
        })
        .catch(error=>{
          this.$store.commit('user/setIsLoading', false);
          console.log('error = ', error);
        });
    },

    signin() {
      this.$store.commit('user/setIsLoading', true);
      this.googleAuth.signIn();
      // const data = {
      //   name: this.name,
      //   password: this.password,
      //   client: "PC",
      // };
      
      // this.$socket.emit("join", data);
    },

    signout() {
      //this.$store.commit('user/delUser');
      //removeAll(this.$socket);
      this.$socket.socket.disconnect();
      this.googleAuth.signOut();
    }
  },
};
</script>
